All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Visualization

## Classes

class | roboptim::visualization::gnuplot::Command
| Gnuplot command. More...
class | roboptim::visualization::Gnuplot
| Gnuplot script. More...

## Typedefs

typedef Function::discreteInterval_t | roboptim::visualization::gnuplot::discreteInterval_t
| Import discrete interval type from function. More...
typedef DifferentiableFunction::argument_t | roboptim::visualization::gnuplot::argument_t
| Import discrete interval type from function. More...

## Functions

ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::comment (const char *) throw ()
| Make a Gnuplot comment. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::set (const char *var, const char *val="") throw ()
| Make a Gnuplot set command. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::unset (const char *var) throw ()
| Make a Gnuplot unset command. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::show (const char *var) throw ()
| Make a Gnuplot show command. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::clear () throw ()
| Make a Gnuplot clear command. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::pwd () throw ()
| Make a Gnuplot pwdcommand. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::quit () throw ()
| Make a Gnuplot quit command. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::replot () throw ()
| Make a Gnuplot replot command. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::reread () throw ()
| Make a Gnuplot reread command. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::reset () throw ()
| Make a Gnuplot reset command. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::cd (const char *dir) throw ()
| Make a Gnuplot cd command. More...
ROBOPTIM_DLLAPI Command | roboptim::visualization::gnuplot::help (const char *topic="") throw ()
| Make a Gnuplot help command. More...
Command | roboptim::visualization::gnuplot::plot_jac (const DifferentiableFunction &f, const DifferentiableFunction::argument_t &arg)
| Plot the Jacobian with Gnuplot. More...
template<typename T >
Command | roboptim::visualization::gnuplot::plot (const GenericFunction< T > &f, discreteInterval_t interval)
| Plot a 1D function with Gnuplot. More...
template<typename T >
Command | roboptim::visualization::gnuplot::plot_xy (const GenericFunction< T > &f, discreteInterval_t interval)
| Plot a 2D function with Gnuplot. More...
double | roboptim::visualization::normalize (const double &x)
| Normalize floating point number output. More...
Eigen::MatrixXd | roboptim::visualization::normalize (const Eigen::MatrixXd &x)
| Apply normalize to each element of a matrix. More...
template<typename T >
T | roboptim::visualization::normalize (const T &x)
| Apply normalize to each element of a container. More...
template<typename T >
Gnuplot & | roboptim::visualization::operator<< (Gnuplot &gp, T t)
| Override operator<< to handle Gnuplot command insertion. More...

## Detailed Description

## Typedef Documentation

typedef DifferentiableFunction::argument_t roboptim::visualization::gnuplot::argument_t

Import discrete interval type from function.

Examples:
  visualization-gnuplot-function.cc.

typedef Function::discreteInterval_t roboptim::visualization::gnuplot::discreteInterval_t

Import discrete interval type from function.

## Function Documentation

ROBOPTIM_DLLAPI Command roboptim::visualization::gnuplot::cd | ( | const char * | dir | ) |
throw | ( |
| ) |  |

Make a Gnuplot cd command.

Make a Gnuplot cd command (change current directory).

Parameters

  dir | new directory

Returns
  Gnuplot command

Examples:
  visualization-gnuplot-simple.cc.

ROBOPTIM_DLLAPI Command roboptim::visualization::gnuplot::clear | ( |  | ) |
throw | ( |
| ) |  |

Make a Gnuplot clear command.

Make a Gnuplot clear command (clear the screen).

Returns
  Gnuplot command

Command roboptim::visualization::gnuplot::comment | ( | const char * | content | ) |
throw | ( |
| ) |  |

Make a Gnuplot comment.

Examples:
  visualization-gnuplot-function.cc, and visualization-gnuplot-simple.cc.

Referenced by roboptim::visualization::Gnuplot::Gnuplot().

ROBOPTIM_DLLAPI Command roboptim::visualization::gnuplot::help | ( | const char * | topic = `""` | ) |
throw | ( |
| ) |  |

Make a Gnuplot help command.

Make a Gnuplot help command (display Gnuplot help).

Parameters

  topic | help topic

Returns
  Gnuplot command

double roboptim::visualization::normalize | ( | const double & | x | ) |

inline

Normalize floating point number output.

Normalization is done on all displayed floating point numbers to get a consistent output.

Referenced by roboptim::visualization::normalize(), roboptim::visualization::gnuplot::plot(), roboptim::visualization::gnuplot::plot_jac(), and roboptim::visualization::gnuplot::plot_xy().

Eigen::MatrixXd roboptim::visualization::normalize | ( | const Eigen::MatrixXd & | x | ) |

inline

Apply normalize to each element of a matrix.

References roboptim::visualization::normalize().

template<typename T >

T roboptim::visualization::normalize | ( | const T & | x | ) |

Apply normalize to each element of a container.

template<typename T >

Gnuplot& roboptim::visualization::operator<< | ( | Gnuplot & | gp,
|  | T | t
| ) |  |

Override operator<< to handle Gnuplot command insertion.

Template Parameters

  Gnuplot | command type

Parameters

  gp | Gnuplot script that will receive the new command
  t | new Gnuplot command.

Returns
  modified Gnuplot script

References roboptim::visualization::Gnuplot::push_command().

template<typename T >

Command roboptim::visualization::gnuplot::plot | ( | const GenericFunction< T > & | f,
|  | discreteInterval_t | interval
| ) |  |

Plot a 1D function with Gnuplot.

Plot a 1D function in Gnuplot on a specific interval. X axis is the function's argument, Y axis is result.

Parameters

  f | function to be plotted
  interval | plot interval

Returns
  Gnuplot command

Examples:
  finite-difference-gradient.cc, and visualization-gnuplot-function.cc.

References roboptim::GenericFunction< T >::getName(), roboptim::GenericFunction< T >::inputSize(), roboptim::visualization::normalize(), and roboptim::GenericFunction< T >::outputSize().

Command roboptim::visualization::gnuplot::plot_jac | ( | const DifferentiableFunction & | f,
|  | const DifferentiableFunction::argument_t & | arg
| ) |  |

Plot the Jacobian with Gnuplot.

Plot the Jacobian of a differentiable function with Gnuplot.

Parameters

  f | differentiable function whose Jacobian will be plotted
  arg | optimization parameters of the point to plot

Returns
  Gnuplot command

References roboptim::GenericFunction< T >::getName(), roboptim::GenericDifferentiableFunction< T >::jacobian(), and roboptim::visualization::normalize().

template<typename T >

Command roboptim::visualization::gnuplot::plot_xy | ( | const GenericFunction< T > & | f,
|  | discreteInterval_t | interval
| ) |  |

Plot a 2D function with Gnuplot.

Plot a 2D function in Gnuplot on a specific interval. X and Y axises are the function result, the original arguments are not displayed.

Parameters

  f | function to be plotted
  interval | plot interval

Returns
  Gnuplot command

Examples:
  visualization-gnuplot-function.cc.

References roboptim::GenericFunction< T >::getName(), roboptim::GenericFunction< T >::inputSize(), roboptim::visualization::normalize(), and roboptim::GenericFunction< T >::outputSize().

ROBOPTIM_DLLAPI Command roboptim::visualization::gnuplot::pwd | ( |  | ) |
throw | ( |
| ) |  |

Make a Gnuplot pwdcommand.

Make a Gnuplot pwd command (show the current directory).

Returns
  Gnuplot command

ROBOPTIM_DLLAPI Command roboptim::visualization::gnuplot::quit | ( |  | ) |
throw | ( |
| ) |  |

Make a Gnuplot quit command.

Make a Gnuplot quit command (quit Gnuplot).

Returns
  Gnuplot command

ROBOPTIM_DLLAPI Command roboptim::visualization::gnuplot::replot | ( |  | ) |
throw | ( |
| ) |  |

Make a Gnuplot replot command.

Make a Gnuplot replot command (redraw previously defined curves).

Returns
  Gnuplot command

ROBOPTIM_DLLAPI Command roboptim::visualization::gnuplot::reread | ( |  | ) |
throw | ( |
| ) |  |

Make a Gnuplot reread command.

Make a Gnuplot reread command (reread data files).

Returns
  Gnuplot command

ROBOPTIM_DLLAPI Command roboptim::visualization::gnuplot::reset | ( |  | ) |
throw | ( |
| ) |  |

Make a Gnuplot reset command.

Make a Gnuplot replot command (reset Gnuplot state).

Returns
  Gnuplot command

Examples:
  visualization-gnuplot-simple.cc.

Command roboptim::visualization::gnuplot::set | ( | const char * | var,
|  | const char * | val = `""`
| ) |  |
throw | ( |
| ) |  |

Make a Gnuplot set command.

Make a Gnuplot set command (assign a new value to a variable in Gnuplot).

Parameters

  var | variable that will be set
  val | new variable value

Returns
  Gnuplot command

Examples:
  finite-difference-gradient.cc, visualization-gnuplot-function.cc, and visualization-gnuplot-simple.cc.

Referenced by roboptim::visualization::Gnuplot::make_interactive_gnuplot().

Command roboptim::visualization::gnuplot::show | ( | const char * | var | ) |
throw | ( |
| ) |  |

Make a Gnuplot show command.

Make a Gnuplot show command (show a variable value).

Parameters

  var | variable that will be shown

Returns
  Gnuplot command

Command roboptim::visualization::gnuplot::unset | ( | const char * | var | ) |
throw | ( |
| ) |  |

Make a Gnuplot unset command.

Make a Gnuplot unset command (destroy a variable).

Parameters

  var | variable that will be unset

Returns
  Gnuplot command

Examples:
  finite-difference-gradient.cc, and visualization-gnuplot-function.cc.